From 5df0a71dcf5a989bfc578bc9a6718b609b6062b0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 24 2020 19:58:58 +0000
Subject: [PATCH 924/2232] Add test for CxxVector::as_slice


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 2829fef..73d6376 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -6,7 +6,7 @@
 
 pub mod module;
 
-use cxx::{CxxString, UniquePtr};
+use cxx::{CxxString, CxxVector, UniquePtr};
 use std::fmt::{self, Display};
 
 #[cxx::bridge(namespace = tests)]
@@ -144,6 +144,7 @@ pub mod ffi {
         fn r_take_sliceu8(s: &[u8]);
         fn r_take_rust_string(s: String);
         fn r_take_unique_ptr_string(s: UniquePtr<CxxString>);
+        fn r_take_ref_vector(v: &CxxVector<u8>);
         fn r_take_rust_vec(v: Vec<u8>);
         fn r_take_rust_vec_string(v: Vec<String>);
         fn r_take_ref_rust_vec(v: &Vec<u8>);
@@ -307,6 +308,11 @@ fn r_take_unique_ptr_string(s: UniquePtr<CxxString>) {
     assert_eq!(s.as_ref().unwrap().to_str().unwrap(), "2020");
 }
 
+fn r_take_ref_vector(v: &CxxVector<u8>) {
+    let slice = v.as_slice();
+    assert_eq!(slice, [20, 2, 0]);
+}
+
 fn r_take_rust_vec(v: Vec<u8>) {
     let _ = v;
 }
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 8dd16e8..a107c48 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -399,6 +399,7 @@ extern "C" const char *cxx_run_test() noexcept {
   r_take_rust_string(rust::String("2020"));
   r_take_unique_ptr_string(
       std::unique_ptr<std::string>(new std::string("2020")));
+  r_take_ref_vector(std::vector<uint8_t>{20, 2, 0});
   r_take_enum(Enum::AVal);
 
   ASSERT(r_try_return_primitive() == 2020);

